//Pin to connect to the circuit
//Setting the pin LOW will tune the coil
//meaning it will respond as a high signal to the reader
//Setting the pin to HIGH will detune coil
//meaning the reader will see it as a low signal
const int coil_pin = 9;
const int led_pin = 13;

unsigned char data_hex[5]={'V','Z', 0x69, 0x8E, 0xA3}; // Сюда вписываем код брелка

//this is the card data we're spoofing.  It's basically 10 hex F's
unsigned char data_to_spoof[64] = {1,1,1,1,1,1,1,1,1, 1,1,1,1,0 ,1,1,1,1,0, 1,1,1,1,0 ,1,1,1,1,0, 1,1,1,1,0 ,1,1,1,1,0, 1,1,1,1,0 ,1,1,1,1,0, 1,1,1,1,0 ,1,1,1,1,0, 0,0,0,0,0};

unsigned int count=0;
  
void setup()
{
  //Set pin as output
  pinMode(coil_pin, OUTPUT);

  //Set pin as output
  pinMode(led_pin, OUTPUT);
      
  //Start it as low
  digitalWrite(coil_pin, LOW);

    //Initialize serial
  Serial.begin(9600);

for(unsigned char i = 0; i < 4; i++)
  {
  data_to_spoof[9+i]=(data_hex[0]>>(7-i))&0x01;
  data_to_spoof[14+i]=(data_hex[0]>>(3-i))&0x01;

  data_to_spoof[19+i]=(data_hex[1]>>(7-i))&0x01;
  data_to_spoof[24+i]=(data_hex[1]>>(3-i))&0x01;

  data_to_spoof[29+i]=(data_hex[2]>>(7-i))&0x01;
  data_to_spoof[34+i]=(data_hex[2]>>(3-i))&0x01;

  data_to_spoof[39+i]=(data_hex[3]>>(7-i))&0x01;
  data_to_spoof[44+i]=(data_hex[3]>>(3-i))&0x01;

  data_to_spoof[49+i]=(data_hex[4]>>(7-i))&0x01;
  data_to_spoof[54+i]=(data_hex[4]>>(3-i))&0x01;
  }
  
  // Row parity
data_to_spoof[13]=(data_to_spoof[9]^data_to_spoof[10]^data_to_spoof[11]^data_to_spoof[12])&0x01;
data_to_spoof[18]=(data_to_spoof[14]^data_to_spoof[15]^data_to_spoof[16]^data_to_spoof[17])&0x01;
data_to_spoof[23]=(data_to_spoof[19]^data_to_spoof[20]^data_to_spoof[21]^data_to_spoof[22])&0x01;
data_to_spoof[28]=(data_to_spoof[24]^data_to_spoof[25]^data_to_spoof[26]^data_to_spoof[27])&0x01;
data_to_spoof[33]=(data_to_spoof[29]^data_to_spoof[30]^data_to_spoof[31]^data_to_spoof[32])&0x01;
data_to_spoof[38]=(data_to_spoof[34]^data_to_spoof[35]^data_to_spoof[36]^data_to_spoof[37])&0x01;
data_to_spoof[43]=(data_to_spoof[39]^data_to_spoof[40]^data_to_spoof[41]^data_to_spoof[42])&0x01;
data_to_spoof[48]=(data_to_spoof[44]^data_to_spoof[45]^data_to_spoof[46]^data_to_spoof[47])&0x01;
data_to_spoof[53]=(data_to_spoof[49]^data_to_spoof[50]^data_to_spoof[51]^data_to_spoof[52])&0x01;
data_to_spoof[58]=(data_to_spoof[54]^data_to_spoof[55]^data_to_spoof[56]^data_to_spoof[57])&0x01;
// Column parity
data_to_spoof[59]=(data_to_spoof[9]^data_to_spoof[14]^data_to_spoof[19]^data_to_spoof[24]^data_to_spoof[29]^data_to_spoof[34]^data_to_spoof[39]^data_to_spoof[44]^data_to_spoof[49]^data_to_spoof[54])&0x01;
data_to_spoof[60]=(data_to_spoof[10]^data_to_spoof[15]^data_to_spoof[20]^data_to_spoof[25]^data_to_spoof[30]^data_to_spoof[35]^data_to_spoof[40]^data_to_spoof[45]^data_to_spoof[50]^data_to_spoof[55])&0x01;
data_to_spoof[61]=(data_to_spoof[11]^data_to_spoof[16]^data_to_spoof[21]^data_to_spoof[26]^data_to_spoof[31]^data_to_spoof[36]^data_to_spoof[41]^data_to_spoof[46]^data_to_spoof[51]^data_to_spoof[56])&0x01;
data_to_spoof[62]=(data_to_spoof[12]^data_to_spoof[17]^data_to_spoof[22]^data_to_spoof[27]^data_to_spoof[32]^data_to_spoof[37]^data_to_spoof[42]^data_to_spoof[47]^data_to_spoof[52]^data_to_spoof[57])&0x01;

Serial.print(data_hex[0], HEX);
Serial.print(data_hex[1], HEX);
Serial.print(data_hex[2], HEX);
Serial.print(data_hex[3], HEX);
Serial.println(data_hex[4], HEX);

  for(unsigned char j = 0; j < 64; j++)
    Serial.print(data_to_spoof[j], DEC);
}

//Does manchester encoding for signal and sets pins.
//Needs clock and signal to do encoding
void set_pin_manchester(unsigned char clock_half, unsigned char dig_signal)
{
  //manchester encoding is xoring the clock with the signal
  unsigned char man_encoded = clock_half ^ dig_signal;
  
  //if it's 1, set the pin LOW (this will tune the antenna and the reader sees this as a high signal)
  //if it's 0, set the pin to HIGH  (this will detune the antenna and the reader sees this as a low signal)
  if(man_encoded == 1)
  {
     digitalWrite(coil_pin, LOW);
  }
  else
  {
    digitalWrite(coil_pin, HIGH);
  }
}

void loop()
{
   //Start it as low
  if (count&0x01)digitalWrite(led_pin, HIGH);
      else digitalWrite(led_pin, LOW);
      
  for(unsigned char i = 0; i < 64; i++)
  {
    set_pin_manchester(0, data_to_spoof[i]);
    delayMicroseconds(256);
    
    set_pin_manchester(1, data_to_spoof[i]);
    delayMicroseconds(256); 
  }

 
 count++;
}
